﻿#include <math.h>
#include <QPointF>

#ifndef M_PI        /* sometimes defined in math.h */
#define M_PI        3.14159265358979323846
#endif
//! fermi function to decribe parameter depence with respect to x
double fermi(double x, double max, double T, double x0);
//! km distance on a sphere decribed in spheric coordinates
float distance(double lat1, double lon1, double lat2, double lon2);
//! invert symmetric matrix
double** SymMatrixtoTriang(double** m, int dim, short returnlower);
double** CreateMatrix(int dimx, int dimy);
double** CopyMatrix(double** m, int dimx,int dimy);
void DeleteMatrix(double** m, int dimx);
void TranspondMatrix(double** m, int dim);
double** MatrixMatrix(double** m1, int dim1, double** m2, int dim2);
//! solve linear Matrix equation : matrix(A)vec(x) = vec(y), return x*/
double* SymLGS(double** A, double* y, int dim);
//! fit polynom of grad-th degree to a point cloud
/*! dataset p of pointcount points is given in cartesian coordinates. Using
 * simple matrix equation a polynom is found to fit the cloud with respect to
 * the least square method. Returns NULL if not solvable (vertical line e.g.).
 * On succes a array with coefficients is returned, highest grades first.
 */
double* FitPolynom(QPointF* p, int pointcount, int grad);
//! returns polynom (with coefficients p) value at x
double fpln(double x, double* p, int grad);
//! returns the best fitting scale step for plots
double upperscale(float f);
//! return importance list for a curve in 2D
/*! to reduce data and identify the most important data points a list is
 * returned indexing every data point with its iteration step, at which
 * in a data reduction procedure this data point must be considered. In the
 * list the start and end point are indexed with one each. The lower the index
 * the more important is the datapoint within the dataset
 */
int* importance(int count, double* x, double facx, double*y, double facy);
//! returns the best fitting scale step for plots
bool intersect_line_rect(double* xl0, double* yl0, double* xl1, double* yl1,
                         double xr0, double yr0, double xr1, double yr1);
double lattomercator(double lat);   /*!< degree scaled mercator position*/
double mercatortolat(double mlat);  /*!< descaled mercator position*/
double rad(double grad);
double grad(double rad);
double climb_P(double d, double dh, double h_dwn);
